Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -1259,233 +1358,228 @@
 !           ENDIF
 
-          f_shf  = rho_cp / r_a(j,i)
-          f_qsws = f_qsws_veg + f_qsws_soil + f_qsws_liq
-
-!
-!--       Calculate derivative of q_s for Taylor series expansion
-          e_s_dt = e_s * ( 17.269_wp / (t_surface(j,i) - 35.86_wp) -           &
-                           17.269_wp*(t_surface(j,i) - 273.16_wp)              &
-                           / (t_surface(j,i) - 35.86_wp)**2 )
-
-          dq_s_dt = 0.622_wp * e_s_dt / surface_pressure
-
-!
-!--       Add LW up so that it can be removed in prognostic equation
-          rad_net_l(j,i) = rad_net(j,i) + rad_lw_out(nzb,j,i)
-
-!
-!--       Calculate new skin temperature
-          IF ( humidity )  THEN
-
-!
-!--          Numerator of the prognostic equation
-             coef_1 = rad_net_l(j,i) + rad_lw_out_change_0(j,i)                &
-                      * t_surface(j,i) - rad_lw_out(nzb,j,i)                   &
-                      + f_shf * pt1 + f_qsws * ( qv1 - q_s                     &
-                      + dq_s_dt * t_surface(j,i) ) + lambda_surface            &
-                      * t_soil(nzb_soil,j,i)
-
-!
-!--          Denominator of the prognostic equation
-             coef_2 = rad_lw_out_change_0(j,i) + f_qsws * dq_s_dt              &
-                      + lambda_surface + f_shf / exn
-          ELSE
-
-!
-!--          Numerator of the prognostic equation
-             coef_1 = rad_net_l(j,i) + rad_lw_out_change_0(j,i)                &
-                      * t_surface(j,i) - rad_lw_out(nzb,j,i)                   &
-                      + f_shf * pt1  + lambda_surface                          &
-                      * t_soil(nzb_soil,j,i)
-
-!
-!--          Denominator of the prognostic equation
-             coef_2 = rad_lw_out_change_0(j,i) + lambda_surface + f_shf / exn
-
-          ENDIF
-
-          tend = 0.0_wp
-
-!
-!--       Implicit solution when the surface layer has no heat capacity,
-!--       otherwise use RK3 scheme.
-          t_surface_p(j,i) = ( coef_1 * dt_3d * tsc(2) + c_surface_tmp *       &
-                             t_surface(j,i) ) / ( c_surface_tmp + coef_2       &
-                                * dt_3d * tsc(2) ) 
-
-!
-!--       Add RK3 term
-          IF ( c_surface_tmp /= 0.0_wp )  THEN
-
-             t_surface_p(j,i) = t_surface_p(j,i) + dt_3d * tsc(3)              &
-                                * tt_surface_m(j,i)
-
-!
-!--          Calculate true tendency
-             tend = (t_surface_p(j,i) - t_surface(j,i) - dt_3d * tsc(3)        &
-                    * tt_surface_m(j,i)) / (dt_3d  * tsc(2))
-!
-!--          Calculate t_surface tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   tt_surface_m(j,i) = tend
-                ELSEIF ( intermediate_timestep_count <                         &
-                         intermediate_timestep_count_max )  THEN
-                   tt_surface_m(j,i) = -9.5625_wp * tend + 5.3125_wp           &
-                                       * tt_surface_m(j,i)
-                ENDIF
+       f_shf  = rho_cp / surf%r_a(m)
+       f_qsws = f_qsws_veg + f_qsws_soil + f_qsws_liq
+!
+!--    Calculate derivative of q_s for Taylor series expansion
+       e_s_dt = e_s * ( 17.269_wp / ( surf_t_surface%var_1d(m) - 35.86_wp) -   &
+                        17.269_wp*( surf_t_surface%var_1d(m) - 273.16_wp)      &
+                       / ( surf_t_surface%var_1d(m) - 35.86_wp)**2 )
+
+       dq_s_dt = 0.622_wp * e_s_dt / surface_pressure
+!
+!--    Add LW up so that it can be removed in prognostic equation
+       surf%rad_net_l(m) = rad_net(j,i) + rad_lw_out(nzb,j,i)
+!
+!--    Calculate new skin temperature
+       IF ( humidity )  THEN
+!
+!--       Numerator of the prognostic equation
+          coef_1 = surf%rad_net_l(m) + rad_lw_out_change_0(j,i)                &
+                   * surf_t_surface%var_1d(m) - rad_lw_out(nzb,j,i)            &
+                   + f_shf * pt1 + f_qsws * ( qv1 - q_s                        &
+                   + dq_s_dt * surf_t_surface%var_1d(m) ) + lambda_surface     &
+                   * surf_t_soil%var_2d(nzb_soil,m)
+!
+!--       Denominator of the prognostic equation
+          coef_2 = rad_lw_out_change_0(j,i) + f_qsws * dq_s_dt                 &
+                   + lambda_surface + f_shf / exn
+       ELSE
+!
+!--       Numerator of the prognostic equation
+          coef_1 = surf%rad_net_l(m) + rad_lw_out_change_0(j,i)                &
+                   * surf_t_surface%var_1d(m) - rad_lw_out(nzb,j,i)            &
+                   + f_shf * pt1  + lambda_surface                             &
+                   * surf_t_soil%var_2d(nzb_soil,m)
+!
+!--       Denominator of the prognostic equation
+          coef_2 = rad_lw_out_change_0(j,i) + lambda_surface + f_shf / exn
+
+       ENDIF
+
+       tend = 0.0_wp
+
+!
+!--    Implicit solution when the surface layer has no heat capacity,
+!--    otherwise use RK3 scheme.
+       surf_t_surface_p%var_1d(m) = ( coef_1 * dt_3d * tsc(2) + c_surface_tmp *&
+                          surf_t_surface%var_1d(m) ) / ( c_surface_tmp + coef_2&
+                                             * dt_3d * tsc(2) ) 
+
+!
+!--    Add RK3 term
+       IF ( c_surface_tmp /= 0.0_wp )  THEN
+
+          surf_t_surface_p%var_1d(m) = surf_t_surface_p%var_1d(m) + dt_3d *    &
+                                       tsc(3) * surf_tt_surface_m%var_1d(m)
+
+!
+!--       Calculate true tendency
+          tend = ( surf_t_surface_p%var_1d(m) - surf_t_surface%var_1d(m) -     &
+                   dt_3d * tsc(3) * surf_tt_surface_m%var_1d(m)) / (dt_3d  * tsc(2))
+!
+!--       Calculate t_surface tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                surf_tt_surface_m%var_1d(m) = tend
+             ELSEIF ( intermediate_timestep_count <                            &
+                      intermediate_timestep_count_max )  THEN
+                surf_tt_surface_m%var_1d(m) = -9.5625_wp * tend +              &
+                                               5.3125_wp * surf_tt_surface_m%var_1d(m)
              ENDIF
           ENDIF
-
-!
-!--       In case of fast changes in the skin temperature, it is possible to
-!--       update the radiative fluxes independently from the prescribed
-!--       radiation call frequency. This effectively prevents oscillations,
-!--       especially when setting skip_time_do_radiation /= 0. The threshold
-!--       value of 0.2 used here is just a first guess. This method should be
-!--       revised in the future as tests have shown that the threshold is 
-!--       often reached, when no oscillations would occur (causes immense
-!--       computing time for the radiation code).
-          IF ( ABS( t_surface_p(j,i) - t_surface(j,i) ) > 0.2_wp  .AND.        &
-               unscheduled_radiation_calls )  THEN
-             force_radiation_call_l = .TRUE.
-          ENDIF
-
-          pt(k,j,i) = t_surface_p(j,i) / exn
-
-!
-!--       Calculate fluxes
-          rad_net_l(j,i)   = rad_net_l(j,i) + rad_lw_out_change_0(j,i)         &
-                             * t_surface(j,i) - rad_lw_out(nzb,j,i)            &
-                             - rad_lw_out_change_0(j,i) * t_surface_p(j,i)
-
-          rad_net(j,i) = rad_net_l(j,i)
-          rad_lw_out(nzb,j,i) = rad_lw_out(nzb,j,i) + rad_lw_out_change_0(j,i) &
-                                * ( t_surface_p(j,i) - t_surface(j,i) )
-
-          ghf_eb(j,i)    = lambda_surface * (t_surface_p(j,i)                  &
-                           - t_soil(nzb_soil,j,i))
-
-          shf_eb(j,i)    = - f_shf * ( pt1 - pt(k,j,i) )
-
-          shf(j,i) = shf_eb(j,i) / rho_cp
-
-          IF ( humidity )  THEN
-             qsws_eb(j,i)  = - f_qsws    * ( qv1 - q_s + dq_s_dt               &
-                             * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )
-
-             qsws(j,i) = qsws_eb(j,i) / rho_lv
-
-             qsws_veg_eb(j,i)  = - f_qsws_veg  * ( qv1 - q_s                   &
-                                 + dq_s_dt * t_surface(j,i) - dq_s_dt          &
-                                 * t_surface_p(j,i) )
-
-             qsws_soil_eb(j,i) = - f_qsws_soil * ( qv1 - q_s                   &
-                                 + dq_s_dt * t_surface(j,i) - dq_s_dt          &
-                                 * t_surface_p(j,i) )
-
-             qsws_liq_eb(j,i)  = - f_qsws_liq  * ( qv1 - q_s                   &
-                                 + dq_s_dt * t_surface(j,i) - dq_s_dt          &
-                                 * t_surface_p(j,i) )
-          ENDIF
-
-!
-!--       Calculate the true surface resistance
-          IF ( qsws_eb(j,i) == 0.0_wp )  THEN
-             r_s(j,i) = 1.0E10_wp
-          ELSE
-             r_s(j,i) = - rho_lv * ( qv1 - q_s + dq_s_dt                       &
-                        * t_surface(j,i) - dq_s_dt * t_surface_p(j,i) )        &
-                        / qsws_eb(j,i) - r_a(j,i)
-          ENDIF
-
-!
-!--       Calculate change in liquid water reservoir due to dew fall or 
-!--       evaporation of liquid water
-          IF ( humidity )  THEN
-!
-!--          If precipitation is activated, add rain water to qsws_liq_eb
-!--          and qsws_soil_eb according the the vegetation coverage.
-!--          precipitation_rate is given in mm.
-             IF ( precipitation )  THEN
-
-!
-!--             Add precipitation to liquid water reservoir, if possible.
-!--             Otherwise, add the water to soil. In case of
-!--             pavements, the exceeding water amount is implicitely removed 
-!--             as runoff as qsws_soil_eb is then not used in the soil model
-                IF ( m_liq_eb(j,i) /= m_liq_eb_max )  THEN
-                   qsws_liq_eb(j,i) = qsws_liq_eb(j,i)                         &
-                                    + c_veg(j,i) * prr(k,j,i) * hyrho(k)       &
-                                    * 0.001_wp * rho_l * l_v
-                ELSE
-                   qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                       &
-                                     + c_veg(j,i) * prr(k,j,i) * hyrho(k)      &
-                                     * 0.001_wp * rho_l * l_v
-                ENDIF
-
-!--             Add precipitation to bare soil according to the bare soil
-!--             coverage.
-                qsws_soil_eb(j,i) = qsws_soil_eb(j,i) + (1.0_wp                &
-                                    - c_veg(j,i)) * prr(k,j,i) * hyrho(k)      &
-                                    * 0.001_wp * rho_l * l_v
+       ENDIF
+
+!
+!--    In case of fast changes in the skin temperature, it is possible to
+!--    update the radiative fluxes independently from the prescribed
+!--    radiation call frequency. This effectively prevents oscillations,
+!--    especially when setting skip_time_do_radiation /= 0. The threshold
+!--    value of 0.2 used here is just a first guess. This method should be
+!--    revised in the future as tests have shown that the threshold is 
+!--    often reached, when no oscillations would occur (causes immense
+!--    computing time for the radiation code).
+       IF ( ABS( surf_t_surface_p%var_1d(m) - surf_t_surface%var_1d(m) ) > 0.2_wp  .AND. &
+            unscheduled_radiation_calls )  THEN
+          force_radiation_call_l = .TRUE.
+       ENDIF
+
+       pt(k+k_off,j+j_off,i+i_off) = surf_t_surface_p%var_1d(m) / exn  !is actually no air temperature
+       surf%pt_surface(m)          = surf_t_surface_p%var_1d(m) / exn
+
+!
+!--    Calculate fluxes
+       surf%rad_net_l(m) = surf%rad_net_l(m) +                                 &
+                            rad_lw_out_change_0(j,i)                           &
+                          * surf_t_surface%var_1d(m) - rad_lw_out(nzb,j,i)     &
+                          - rad_lw_out_change_0(j,i) * surf_t_surface_p%var_1d(m)
+
+       rad_net(j,i) = surf%rad_net_l(m)
+       rad_lw_out(nzb,j,i) = rad_lw_out(nzb,j,i) + rad_lw_out_change_0(j,i) *  &
+                     ( surf_t_surface_p%var_1d(m) - surf_t_surface%var_1d(m) )
+
+       surf%ghf_eb(m) = lambda_surface * ( surf_t_surface_p%var_1d(m)          &
+                                             - surf_t_soil%var_2d(nzb_soil,m) )
+
+       surf%shf_eb(m) = - f_shf * ( pt1 - surf%pt_surface(m) )
+
+       surf%shf(m) = surf%shf_eb(m) / rho_cp
+
+       IF ( humidity )  THEN
+          surf%qsws_eb(m)  = - f_qsws * ( qv1 - q_s + dq_s_dt                  &
+                          * surf_t_surface%var_1d(m) - dq_s_dt *               &
+                            surf_t_surface_p%var_1d(m) )
+
+          surf%qsws(m) = surf%qsws_eb(m) / rho_lv
+
+          surf%qsws_veg_eb(m)  = - f_qsws_veg  * ( qv1 - q_s                   &
+                              + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
+                              * surf_t_surface_p%var_1d(m) )
+
+          surf%qsws_soil_eb(m) = - f_qsws_soil * ( qv1 - q_s                   &
+                              + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
+                              * surf_t_surface_p%var_1d(m) )
+
+          surf%qsws_liq_eb(m)  = - f_qsws_liq  * ( qv1 - q_s                   &
+                              + dq_s_dt * surf_t_surface%var_1d(m) - dq_s_dt   &
+                              * surf_t_surface_p%var_1d(m) )
+       ENDIF
+
+!
+!--    Calculate the true surface resistance
+       IF ( surf%qsws_eb(m) == 0.0_wp )  THEN
+          surf%r_s(m) = 1.0E10_wp
+       ELSE
+          surf%r_s(m) = - rho_lv * ( qv1 - q_s + dq_s_dt                       &
+                          * surf_t_surface%var_1d(m) - dq_s_dt *               &
+                            surf_t_surface_p%var_1d(m) ) /                     &
+                            surf%qsws_eb(m) - surf%r_a(m)
+       ENDIF
+
+!
+!--    Calculate change in liquid water reservoir due to dew fall or 
+!--    evaporation of liquid water
+       IF ( humidity )  THEN
+!
+!--       If precipitation is activated, add rain water to qsws_liq_eb
+!--       and qsws_soil_eb according the the vegetation coverage.
+!--       precipitation_rate is given in mm.
+          IF ( precipitation )  THEN
+
+!
+!--          Add precipitation to liquid water reservoir, if possible.
+!--          Otherwise, add the water to soil. In case of
+!--          pavements, the exceeding water amount is implicitely removed 
+!--          as runoff as qsws_soil_eb is then not used in the soil model
+             IF ( surf_m_liq_eb%var_1d(m) /= m_liq_eb_max )  THEN
+                surf%qsws_liq_eb(m) = surf%qsws_liq_eb(m)                      &
+                                 + surf%c_veg(m) * prr(k+k_off,j+j_off,i+i_off)&
+                                 * hyrho(k+k_off)                              &
+                                 * 0.001_wp * rho_l * l_v
+             ELSE
+                surf%qsws_soil_eb(m) = surf%qsws_soil_eb(m)                    &
+                                 + surf%c_veg(m) * prr(k+k_off,j+j_off,i+i_off)&
+                                 * hyrho(k+k_off)                              &
+                                 * 0.001_wp * rho_l * l_v
              ENDIF
 
-!
-!--          If the air is saturated, check the reservoir water level
-             IF ( qsws_eb(j,i) < 0.0_wp )  THEN
-
-!
-!--             Check if reservoir is full (avoid values > m_liq_eb_max)
-!--             In that case, qsws_liq_eb goes to qsws_soil_eb. In this 
-!--             case qsws_veg_eb is zero anyway (because c_liq = 1),       
-!--             so that tend is zero and no further check is needed
-                IF ( m_liq_eb(j,i) == m_liq_eb_max )  THEN
-                   qsws_soil_eb(j,i) = qsws_soil_eb(j,i)                       &
-                                        + qsws_liq_eb(j,i)
-
-                   qsws_liq_eb(j,i)  = 0.0_wp
-                ENDIF
-
-!
-!--             In case qsws_veg_eb becomes negative (unphysical behavior), 
-!--             let the water enter the liquid water reservoir as dew on the
-!--             plant
-                IF ( qsws_veg_eb(j,i) < 0.0_wp )  THEN
-                   qsws_liq_eb(j,i) = qsws_liq_eb(j,i) + qsws_veg_eb(j,i)
-                   qsws_veg_eb(j,i) = 0.0_wp
-                ENDIF
-             ENDIF                    
-  
-             tend = - qsws_liq_eb(j,i) * drho_l_lv
-             m_liq_eb_p(j,i) = m_liq_eb(j,i) + dt_3d * ( tsc(2) * tend         &
-                                                + tsc(3) * tm_liq_eb_m(j,i) )
-
-!
-!--          Check if reservoir is overfull -> reduce to maximum
-!--          (conservation of water is violated here)
-             m_liq_eb_p(j,i) = MIN(m_liq_eb_p(j,i),m_liq_eb_max)
-
-!
-!--          Check if reservoir is empty (avoid values < 0.0)
-!--          (conservation of water is violated here)
-             m_liq_eb_p(j,i) = MAX(m_liq_eb_p(j,i),0.0_wp)
-
-
-!
-!--          Calculate m_liq_eb tendencies for the next Runge-Kutta step
-             IF ( timestep_scheme(1:5) == 'runge' )  THEN
-                IF ( intermediate_timestep_count == 1 )  THEN
-                   tm_liq_eb_m(j,i) = tend
-                ELSEIF ( intermediate_timestep_count <                         &
-                         intermediate_timestep_count_max )  THEN
-                   tm_liq_eb_m(j,i) = -9.5625_wp * tend + 5.3125_wp            &
-                                    * tm_liq_eb_m(j,i)
-                ENDIF
+!--          Add precipitation to bare soil according to the bare soil
+!--          coverage.
+             surf%qsws_soil_eb(m) = surf%qsws_soil_eb(m) + ( 1.0_wp            &
+                               - surf%c_veg(m) ) * prr(k+k_off,j+j_off,i+i_off)&
+                               * hyrho(k+k_off)                                &
+                               * 0.001_wp * rho_l * l_v
+          ENDIF
+
+!
+!--       If the air is saturated, check the reservoir water level
+          IF ( surf%qsws_eb(m) < 0.0_wp )  THEN
+!
+!--          Check if reservoir is full (avoid values > m_liq_eb_max)
+!--          In that case, qsws_liq_eb goes to qsws_soil_eb. In this 
+!--          case qsws_veg_eb is zero anyway (because c_liq = 1),       
+!--          so that tend is zero and no further check is needed
+             IF ( surf_m_liq_eb%var_1d(m) == m_liq_eb_max )  THEN
+                surf%qsws_soil_eb(m) = surf%qsws_soil_eb(m) + surf%qsws_liq_eb(m)
+
+                surf%qsws_liq_eb(m)  = 0.0_wp
              ENDIF
 
-          ENDIF
-
-       ENDDO
+!
+!--          In case qsws_veg_eb becomes negative (unphysical behavior), 
+!--          let the water enter the liquid water reservoir as dew on the
+!--          plant
+             IF ( surf%qsws_veg_eb(m) < 0.0_wp )  THEN
+                surf%qsws_liq_eb(m) = surf%qsws_liq_eb(m) + surf%qsws_veg_eb(m)
+                surf%qsws_veg_eb(m) = 0.0_wp
+             ENDIF
+          ENDIF                    
+ 
+          tend = - surf%qsws_liq_eb(m) * drho_l_lv
+          surf_m_liq_eb_p%var_1d(m) = surf_m_liq_eb%var_1d(m) + dt_3d *        &
+                                        ( tsc(2) * tend +                      &
+                                          tsc(3) * surf_tm_liq_eb_m%var_1d(m) )
+!
+!--       Check if reservoir is overfull -> reduce to maximum
+!--       (conservation of water is violated here)
+          surf_m_liq_eb_p%var_1d(m) = MIN( surf_m_liq_eb_p%var_1d(m),m_liq_eb_max )
+
+!
+!--       Check if reservoir is empty (avoid values < 0.0)
+!--       (conservation of water is violated here)
+          surf_m_liq_eb_p%var_1d(m) = MAX( surf_m_liq_eb_p%var_1d(m), 0.0_wp )
+!
+!--       Calculate m_liq_eb tendencies for the next Runge-Kutta step
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( intermediate_timestep_count == 1 )  THEN
+                surf_tm_liq_eb_m%var_1d(m) = tend
+             ELSEIF ( intermediate_timestep_count <                            &
+                      intermediate_timestep_count_max )  THEN
+                surf_tm_liq_eb_m%var_1d(m) = -9.5625_wp * tend +               &
+                                              5.3125_wp * surf_tm_liq_eb_m%var_1d(m)
+             ENDIF
+          ENDIF
+
+       ENDIF
+
     ENDDO
 
@@ -1497,5 +1591,5 @@
 #if defined( __parallel )
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( force_radiation_call_l, force_radiation_call,    &
+       CALL MPI_ALLREDUCE( force_radiation_call_l, force_radiation_call,       &
                            1, MPI_LOGICAL, MPI_LOR, comm2d, ierr )
 #else
@@ -1513,5 +1607,59 @@
 !
 !-- Calculate new roughness lengths (for water surfaces only)
-    CALL calc_z0_water_surface
+    IF ( horizontal )  CALL calc_z0_water_surface
+
+    CONTAINS
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculation of specific humidity of the skin layer (surface). It is assumend
+!> that the skin is always saturated.
+!------------------------------------------------------------------------------!
+    SUBROUTINE calc_q_surface
+
+       IMPLICIT NONE
+
+       REAL(wp) :: resistance    !< aerodynamic and soil resistance term
+
+       DO  m = 1, surf%ns
+
+          i   = surf%i(m)            
+          j   = surf%j(m)
+          k   = surf%k(m)
+
+!
+!--       Calculate water vapour pressure at saturation
+          e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp *                         &
+                                 ( surf_t_surface_p%var_1d(m) - 273.16_wp ) /  &
+                                 ( surf_t_surface_p%var_1d(m) - 35.86_wp  )    &
+                                         )
+
+!
+!--       Calculate specific humidity at saturation
+          q_s = 0.622_wp * e_s / surface_pressure
+
+          resistance = surf%r_a(m) / ( surf%r_a(m) + surf%r_s(m) )
+
+!
+!--       Calculate specific humidity at surface
+          IF ( cloud_physics )  THEN
+             q(k+k_off,j+j_off,i+i_off) = resistance * q_s +                   &
+                                        ( 1.0_wp - resistance ) *              &
+                                        ( q(k,j,i) - ql(k,j,i) )
+          ELSE
+             q(k+k_off,j+j_off,i+i_off) = resistance * q_s +                   &
+                                        ( 1.0_wp - resistance ) *              &
+                                          q(k,j,i)
+          ENDIF
+
+!
+!--       Update virtual potential temperature
+          vpt(k+k_off,j+j_off,i+i_off) = pt(k+k_off,j+j_off,i+i_off) *         &
+                     ( 1.0_wp + 0.61_wp * q(k+k_off,j+j_off,i+i_off) )
+
+       ENDDO
+
+    END SUBROUTINE calc_q_surface
+
 
 
@@ -1607,16 +1755,17 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i !< running index
-       INTEGER(iwp) ::  j !< running index
-       INTEGER(iwp) ::  k !< running index
+       INTEGER(iwp) ::  i     !< running index
+       INTEGER(iwp) ::  i_off !< index offset of surface element, seen from atmospheric grid point 
+       INTEGER(iwp) ::  j     !< running index
+       INTEGER(iwp) ::  j_off !< index offset of surface element, seen from atmospheric grid point 
+       INTEGER(iwp) ::  k     !< running index
+       INTEGER(iwp) ::  l     !< running index surface facing
+       INTEGER(iwp) ::  m     !< running index
 
        REAL(wp) :: pt1   !< potential temperature at first grid level
-
 
 !
 !--    Calculate Exner function
        exn = ( surface_pressure / 1000.0_wp )**0.286_wp
-
-
 !
 !--    If no cloud physics is used, rho_surface has not been calculated before
@@ -1634,43 +1783,89 @@
 !
 !--    Set inital values for prognostic quantities
-       tt_surface_m = 0.0_wp
-       tt_soil_m    = 0.0_wp
-       tm_soil_m    = 0.0_wp
-       tm_liq_eb_m  = 0.0_wp
-       c_liq        = 0.0_wp
-
-       ghf_eb = 0.0_wp
-       shf_eb = rho_cp * shf
+!--    Horizontal surfaces
+       tt_surface_h_m%var_1d = 0.0_wp
+       tt_soil_h_m%var_2d    = 0.0_wp
+       tm_soil_h_m%var_2d    = 0.0_wp
+       tm_liq_eb_h_m%var_1d  = 0.0_wp
+       surf_lsm_h%c_liq = 0.0_wp
+
+       surf_lsm_h%ghf_eb = 0.0_wp
+       surf_lsm_h%shf_eb = rho_cp * surf_lsm_h%shf
 
        IF ( humidity )  THEN
-          qsws_eb = rho_lv * qsws
+          surf_lsm_h%qsws_eb = rho_lv * surf_lsm_h%qsws
        ELSE
-          qsws_eb = 0.0_wp
-       ENDIF
-
-       qsws_liq_eb  = 0.0_wp
-       qsws_soil_eb = 0.0_wp
-       qsws_veg_eb  = 0.0_wp
-
-       r_a        = 50.0_wp
-       r_s        = 50.0_wp
-       r_canopy   = 0.0_wp
-       r_soil     = 0.0_wp
+          surf_lsm_h%qsws_eb = 0.0_wp
+       ENDIF
+
+       surf_lsm_h%qsws_liq_eb  = 0.0_wp
+       surf_lsm_h%qsws_soil_eb = 0.0_wp
+       surf_lsm_h%qsws_veg_eb  = 0.0_wp
+
+       surf_lsm_h%r_a        = 50.0_wp
+       surf_lsm_h%r_s        = 50.0_wp
+       surf_lsm_h%r_canopy   = 0.0_wp
+       surf_lsm_h%r_soil     = 0.0_wp
+!
+!--    Do the same for vertical surfaces
+       DO  l = 0, 3
+          tt_surface_v_m(l)%var_1d = 0.0_wp
+          tt_soil_v_m(l)%var_2d    = 0.0_wp
+          tm_soil_v_m(l)%var_2d    = 0.0_wp
+          tm_liq_eb_v_m(l)%var_1d  = 0.0_wp
+          surf_lsm_v(l)%c_liq = 0.0_wp
+
+          surf_lsm_v(l)%ghf_eb = 0.0_wp
+          surf_lsm_v(l)%shf_eb = rho_cp * surf_lsm_v(l)%shf
+
+          IF ( humidity )  THEN
+             surf_lsm_v(l)%qsws_eb = rho_lv * surf_lsm_v(l)%qsws
+          ELSE
+             surf_lsm_v(l)%qsws_eb = 0.0_wp
+          ENDIF
+
+          surf_lsm_v(l)%qsws_liq_eb  = 0.0_wp
+          surf_lsm_v(l)%qsws_soil_eb = 0.0_wp
+          surf_lsm_v(l)%qsws_veg_eb  = 0.0_wp
+
+          surf_lsm_v(l)%r_a        = 50.0_wp
+          surf_lsm_v(l)%r_s        = 50.0_wp
+          surf_lsm_v(l)%r_canopy   = 0.0_wp
+          surf_lsm_v(l)%r_soil     = 0.0_wp
+       ENDDO
 
 !
 !--    Allocate 3D soil model arrays
-       ALLOCATE ( root_fr(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( lambda_h(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-       ALLOCATE ( rho_c_total(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-
-       lambda_h = 0.0_wp
+!--    First, for horizontal surfaces
+       ALLOCATE ( surf_lsm_h%root_fr(nzb_soil:nzt_soil,1:surf_lsm_h%ns)     )
+       ALLOCATE ( surf_lsm_h%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_h%ns)    )
+       ALLOCATE ( surf_lsm_h%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
+
+       surf_lsm_h%lambda_h = 0.0_wp
 !
 !--    If required, allocate humidity-related variables for the soil model
        IF ( humidity )  THEN
-          ALLOCATE ( lambda_w(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
-          ALLOCATE ( gamma_w(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )   
-
-          lambda_w = 0.0_wp 
-       ENDIF
+          ALLOCATE ( surf_lsm_h%lambda_w(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
+          ALLOCATE ( surf_lsm_h%gamma_w(nzb_soil:nzt_soil,1:surf_lsm_h%ns)  )  
+
+          surf_lsm_h%lambda_w = 0.0_wp 
+       ENDIF
+!
+!--    For vertical surfaces
+       DO  l = 0, 3
+          ALLOCATE ( surf_lsm_v(l)%root_fr(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)     )
+          ALLOCATE ( surf_lsm_v(l)%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)    )
+          ALLOCATE ( surf_lsm_v(l)%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns) )
+
+          surf_lsm_v(l)%lambda_h = 0.0_wp
+!
+!--       If required, allocate humidity-related variables for the soil model
+          IF ( humidity )  THEN
+             ALLOCATE ( surf_lsm_v(l)%lambda_w(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns) )
+             ALLOCATE ( surf_lsm_v(l)%gamma_w(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)  )  
+
+             surf_lsm_v(l)%lambda_w = 0.0_wp 
+          ENDIF      
+       ENDDO
 
 !
@@ -1735,21 +1930,38 @@
 !
 !--    Map values to the respective 2D arrays
-       alpha_vg      = alpha_vangenuchten
-       l_vg          = l_vangenuchten
-       n_vg          = n_vangenuchten 
-       gamma_w_sat   = hydraulic_conductivity
-       m_sat         = saturation_moisture
-       m_fc          = field_capacity
-       m_wilt        = wilting_point
-       m_res         = residual_moisture
-       r_soil_min    = min_soil_resistance
+!--    Horizontal surfaces
+       surf_lsm_h%alpha_vg      = alpha_vangenuchten
+       surf_lsm_h%l_vg          = l_vangenuchten
+       surf_lsm_h%n_vg          = n_vangenuchten 
+       surf_lsm_h%gamma_w_sat   = hydraulic_conductivity
+       surf_lsm_h%m_sat         = saturation_moisture
+       surf_lsm_h%m_fc          = field_capacity
+       surf_lsm_h%m_wilt        = wilting_point
+       surf_lsm_h%m_res         = residual_moisture
+       surf_lsm_h%r_soil_min    = min_soil_resistance
+!
+!--    Vertical surfaces
+       DO  l = 0, 3
+          surf_lsm_v(l)%alpha_vg      = alpha_vangenuchten
+          surf_lsm_v(l)%l_vg          = l_vangenuchten
+          surf_lsm_v(l)%n_vg          = n_vangenuchten 
+          surf_lsm_v(l)%gamma_w_sat   = hydraulic_conductivity
+          surf_lsm_v(l)%m_sat         = saturation_moisture
+          surf_lsm_v(l)%m_fc          = field_capacity
+          surf_lsm_v(l)%m_wilt        = wilting_point
+          surf_lsm_v(l)%m_res         = residual_moisture
+          surf_lsm_v(l)%r_soil_min    = min_soil_resistance
+       ENDDO
+
+
 
 !
 !--    Initial run actions
        IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
-
-          t_soil    = 0.0_wp
-          m_liq_eb  = 0.0_wp
-          m_soil    = 0.0_wp
+!
+!--       First, for horizontal surfaces
+          t_soil_h%var_2d    = 0.0_wp
+          m_soil_h%var_2d    = 0.0_wp
+          m_liq_eb_h%var_1d  = 0.0_wp
 
 !
